/* Utils.c generated by valac 0.40.7, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define POWER_SERVICES_TYPE_DEVICE (power_services_device_get_type ())
#define POWER_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice))
#define POWER_SERVICES_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))
#define POWER_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))

typedef struct _PowerServicesDevice PowerServicesDevice;
typedef struct _PowerServicesDeviceClass PowerServicesDeviceClass;
#define _g_free0(var) (var = (g_free (var), NULL))



gboolean power_utils_type_is_battery (guint32 device_type);
#define DEVICE_TYPE_UNKNOWN ((guint32) 0)
#define DEVICE_TYPE_LINE_POWER ((guint32) 1)
gboolean power_utils_type_has_device_icon (guint32 device_type);
#define DEVICE_TYPE_PHONE ((guint32) 8)
#define DEVICE_TYPE_MOUSE ((guint32) 5)
#define DEVICE_TYPE_KEYBOARD ((guint32) 6)
GType power_services_device_get_type (void) G_GNUC_CONST;
gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_symbolic_icon_name_for_backlight (void);
gdouble power_services_device_get_percentage (PowerServicesDevice* self);
gboolean power_utils_is_charging (guint32 state);
guint32 power_services_device_get_state (PowerServicesDevice* self);
gchar* power_utils_get_battery_icon (gdouble percentage,
                                     gint64 remaining_time);
gint64 power_services_device_get_time_to_empty (PowerServicesDevice* self);
gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device);
guint32 power_services_device_get_device_type (PowerServicesDevice* self);
#define DEVICE_STATE_FULLY_CHARGED ((guint32) 4)
#define DEVICE_STATE_CHARGING ((guint32) 1)
gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery);
#define DEVICE_TYPE_BATTERY ((guint32) 2)
#define DEVICE_TYPE_UPS ((guint32) 3)
#define DEVICE_TYPE_MONITOR ((guint32) 4)
#define DEVICE_TYPE_PDA ((guint32) 7)
const gchar* power_services_device_get_vendor (PowerServicesDevice* self);
const gchar* power_services_device_get_model (PowerServicesDevice* self);
gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery);
gint64 power_services_device_get_time_to_full (PowerServicesDevice* self);
#define CONSTANTS_GETTEXT_PACKAGE "power-indicator"
void power_utils_translations (void);


gboolean
power_utils_type_is_battery (guint32 device_type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (device_type != DEVICE_TYPE_UNKNOWN) {
		_tmp0_ = device_type != DEVICE_TYPE_LINE_POWER;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean
power_utils_type_has_device_icon (guint32 device_type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (device_type == DEVICE_TYPE_PHONE) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = device_type == DEVICE_TYPE_MOUSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = device_type == DEVICE_TYPE_KEYBOARD;
	}
	result = _tmp0_;
	return result;
}


gchar*
power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp0_ = power_utils_get_icon_name_for_battery (battery);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "-symbolic", NULL);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


gchar*
power_utils_get_symbolic_icon_name_for_backlight (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("display-brightness-symbolic");
	result = _tmp0_;
	return result;
}


gchar*
power_utils_get_icon_name_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp1_ = power_services_device_get_percentage (battery);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == ((gdouble) 100)) {
		guint32 _tmp3_;
		guint32 _tmp4_;
		_tmp3_ = power_services_device_get_state (battery);
		_tmp4_ = _tmp3_;
		_tmp0_ = power_utils_is_charging (_tmp4_) == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("battery-full-charged");
		result = _tmp5_;
		return result;
	} else {
		const gchar* _tmp6_ = NULL;
		guint32 _tmp7_;
		guint32 _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gint64 _tmp11_;
		gint64 _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp7_ = power_services_device_get_state (battery);
		_tmp8_ = _tmp7_;
		if (power_utils_is_charging (_tmp8_)) {
			_tmp6_ = "-charging";
		} else {
			_tmp6_ = "";
		}
		_tmp9_ = power_services_device_get_percentage (battery);
		_tmp10_ = _tmp9_;
		_tmp11_ = power_services_device_get_time_to_empty (battery);
		_tmp12_ = _tmp11_;
		_tmp13_ = power_utils_get_battery_icon (_tmp10_, _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strconcat (_tmp14_, _tmp6_, NULL);
		_tmp16_ = _tmp15_;
		_g_free0 (_tmp14_);
		result = _tmp16_;
		return result;
	}
}


gchar*
power_utils_get_icon_name_for_device (PowerServicesDevice* device)
{
	gchar* result = NULL;
	guint32 _tmp0_;
	guint32 _tmp1_;
	g_return_val_if_fail (device != NULL, NULL);
	_tmp0_ = power_services_device_get_device_type (device);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case DEVICE_TYPE_PHONE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("phone");
			result = _tmp2_;
			return result;
		}
		case DEVICE_TYPE_MOUSE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("input-mouse");
			result = _tmp3_;
			return result;
		}
		case DEVICE_TYPE_KEYBOARD:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("input-keyboard");
			result = _tmp4_;
			return result;
		}
		default:
		{
			gchar* _tmp5_;
			_tmp5_ = power_utils_get_icon_name_for_battery (device);
			result = _tmp5_;
			return result;
		}
	}
}


gchar*
power_utils_get_battery_icon (gdouble percentage,
                              gint64 remaining_time)
{
	gchar* result = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp7_;
	if (percentage <= ((gdouble) 0)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("battery-good");
		result = _tmp0_;
		return result;
	}
	if (percentage < ((gdouble) 10)) {
		gboolean _tmp2_ = FALSE;
		if (remaining_time == ((gint64) 0)) {
			_tmp2_ = TRUE;
		} else {
			_tmp2_ = remaining_time < ((gint64) (30 * 60));
		}
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("battery-empty");
		result = _tmp3_;
		return result;
	}
	if (percentage < ((gdouble) 30)) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("battery-caution");
		result = _tmp4_;
		return result;
	}
	if (percentage < ((gdouble) 60)) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("battery-low");
		result = _tmp5_;
		return result;
	}
	if (percentage < ((gdouble) 80)) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup ("battery-good");
		result = _tmp6_;
		return result;
	}
	_tmp7_ = g_strdup ("battery-full");
	result = _tmp7_;
	return result;
}


gboolean
power_utils_is_charging (guint32 state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (state == DEVICE_STATE_FULLY_CHARGED) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = state == DEVICE_STATE_CHARGING;
	}
	result = _tmp0_;
	return result;
}


gchar*
power_utils_get_title_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
	gboolean _tmp15_ = FALSE;
	guint32 _tmp16_;
	guint32 _tmp17_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp0_ = g_strdup ("");
	title = _tmp0_;
	_tmp1_ = power_services_device_get_device_type (battery);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case DEVICE_TYPE_BATTERY:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Battery"));
			_g_free0 (title);
			title = _tmp3_;
			break;
		}
		case DEVICE_TYPE_UPS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("UPS"));
			_g_free0 (title);
			title = _tmp4_;
			break;
		}
		case DEVICE_TYPE_MONITOR:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Display"));
			_g_free0 (title);
			title = _tmp5_;
			break;
		}
		case DEVICE_TYPE_MOUSE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Mouse"));
			_g_free0 (title);
			title = _tmp6_;
			break;
		}
		case DEVICE_TYPE_KEYBOARD:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Keyboard"));
			_g_free0 (title);
			title = _tmp7_;
			break;
		}
		case DEVICE_TYPE_PDA:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("PDA"));
			_g_free0 (title);
			title = _tmp8_;
			break;
		}
		case DEVICE_TYPE_PHONE:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("Phone"));
			_g_free0 (title);
			title = _tmp9_;
			break;
		}
		default:
		{
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp10_ = power_services_device_get_vendor (battery);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strconcat (_tmp11_, " ", NULL);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_strconcat (_tmp13_, _ ("Device"), NULL);
			_g_free0 (title);
			title = _tmp14_;
			_g_free0 (_tmp13_);
			break;
		}
	}
	_tmp16_ = power_services_device_get_device_type (battery);
	_tmp17_ = _tmp16_;
	if (_tmp17_ == DEVICE_TYPE_PHONE) {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		_tmp18_ = power_services_device_get_model (battery);
		_tmp19_ = _tmp18_;
		_tmp15_ = g_strcmp0 (_tmp19_, "") != 0;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		_tmp20_ = power_services_device_get_model (battery);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strdup (_tmp21_);
		_g_free0 (title);
		title = _tmp22_;
	}
	_tmp23_ = title;
	_tmp24_ = g_strdup_printf ("<b>%s</b>", _tmp23_);
	result = _tmp24_;
	_g_free0 (title);
	return result;
}


gchar*
power_utils_get_info_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gint percent = 0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean charging = FALSE;
	guint32 _tmp2_;
	guint32 _tmp3_;
	gint _tmp4_;
	gchar* info = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_;
	g_return_val_if_fail (battery != NULL, NULL);
	_tmp0_ = power_services_device_get_percentage (battery);
	_tmp1_ = _tmp0_;
	percent = (gint) round (_tmp1_);
	_tmp2_ = power_services_device_get_state (battery);
	_tmp3_ = _tmp2_;
	charging = power_utils_is_charging (_tmp3_);
	_tmp4_ = percent;
	if (_tmp4_ <= 0) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (_ ("Calculating…"));
		result = _tmp5_;
		return result;
	}
	_tmp6_ = g_strdup ("");
	info = _tmp6_;
	_tmp7_ = charging;
	if (_tmp7_) {
		const gchar* _tmp8_;
		gint _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gint64 seconds = 0LL;
		gint64 _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
		_tmp8_ = info;
		_tmp9_ = percent;
		_tmp10_ = g_strdup_printf (_ ("%i%% charged"), _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strconcat (_tmp8_, _tmp11_, NULL);
		_g_free0 (info);
		info = _tmp12_;
		_g_free0 (_tmp11_);
		_tmp13_ = power_services_device_get_time_to_full (battery);
		_tmp14_ = _tmp13_;
		seconds = _tmp14_;
		_tmp15_ = seconds;
		if (_tmp15_ > ((gint64) 0)) {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gint64 _tmp18_;
			_tmp16_ = info;
			_tmp17_ = g_strconcat (_tmp16_, " - ", NULL);
			_g_free0 (info);
			info = _tmp17_;
			_tmp18_ = seconds;
			if (_tmp18_ >= ((gint64) 86400)) {
				gint64 days = 0LL;
				gint64 _tmp19_;
				const gchar* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				_tmp19_ = seconds;
				days = _tmp19_ / 86400;
				_tmp20_ = info;
				_tmp21_ = days;
				_tmp22_ = days;
				_tmp23_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until full", "%lld days until full", (gulong) _tmp21_), _tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = g_strconcat (_tmp20_, _tmp24_, NULL);
				_g_free0 (info);
				info = _tmp25_;
				_g_free0 (_tmp24_);
			} else {
				gint64 _tmp26_;
				_tmp26_ = seconds;
				if (_tmp26_ >= ((gint64) 3600)) {
					gint64 hours = 0LL;
					gint64 _tmp27_;
					const gchar* _tmp28_;
					gint64 _tmp29_;
					gint64 _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					_tmp27_ = seconds;
					hours = _tmp27_ / 3600;
					_tmp28_ = info;
					_tmp29_ = hours;
					_tmp30_ = hours;
					_tmp31_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until full", "%lld hours until full", (gulong) _tmp29_), _tmp30_);
					_tmp32_ = _tmp31_;
					_tmp33_ = g_strconcat (_tmp28_, _tmp32_, NULL);
					_g_free0 (info);
					info = _tmp33_;
					_g_free0 (_tmp32_);
				} else {
					gint64 _tmp34_;
					_tmp34_ = seconds;
					if (_tmp34_ >= ((gint64) 60)) {
						gint64 minutes = 0LL;
						gint64 _tmp35_;
						const gchar* _tmp36_;
						gint64 _tmp37_;
						gint64 _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						_tmp35_ = seconds;
						minutes = _tmp35_ / 60;
						_tmp36_ = info;
						_tmp37_ = minutes;
						_tmp38_ = minutes;
						_tmp39_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until full", "%lld minutes until full", (gulong) _tmp37_), _tmp38_);
						_tmp40_ = _tmp39_;
						_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
						_g_free0 (info);
						info = _tmp41_;
						_g_free0 (_tmp40_);
					} else {
						const gchar* _tmp42_;
						gint64 _tmp43_;
						gint64 _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						_tmp42_ = info;
						_tmp43_ = seconds;
						_tmp44_ = seconds;
						_tmp45_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until full", "%lld seconds until full", (gulong) _tmp43_), _tmp44_);
						_tmp46_ = _tmp45_;
						_tmp47_ = g_strconcat (_tmp42_, _tmp46_, NULL);
						_g_free0 (info);
						info = _tmp47_;
						_g_free0 (_tmp46_);
					}
				}
			}
		}
	} else {
		const gchar* _tmp48_;
		gint _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gint64 seconds = 0LL;
		gint64 _tmp53_;
		gint64 _tmp54_;
		gint64 _tmp55_;
		_tmp48_ = info;
		_tmp49_ = percent;
		_tmp50_ = g_strdup_printf (_ ("%i%% remaining"), _tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = g_strconcat (_tmp48_, _tmp51_, NULL);
		_g_free0 (info);
		info = _tmp52_;
		_g_free0 (_tmp51_);
		_tmp53_ = power_services_device_get_time_to_empty (battery);
		_tmp54_ = _tmp53_;
		seconds = _tmp54_;
		_tmp55_ = seconds;
		if (_tmp55_ > ((gint64) 0)) {
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gint64 _tmp58_;
			_tmp56_ = info;
			_tmp57_ = g_strconcat (_tmp56_, " - ", NULL);
			_g_free0 (info);
			info = _tmp57_;
			_tmp58_ = seconds;
			if (_tmp58_ >= ((gint64) 86400)) {
				gint64 days = 0LL;
				gint64 _tmp59_;
				const gchar* _tmp60_;
				gint64 _tmp61_;
				gint64 _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				_tmp59_ = seconds;
				days = _tmp59_ / 86400;
				_tmp60_ = info;
				_tmp61_ = days;
				_tmp62_ = days;
				_tmp63_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until empty", "%lld days until empty", (gulong) _tmp61_), _tmp62_);
				_tmp64_ = _tmp63_;
				_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
				_g_free0 (info);
				info = _tmp65_;
				_g_free0 (_tmp64_);
			} else {
				gint64 _tmp66_;
				_tmp66_ = seconds;
				if (_tmp66_ >= ((gint64) 3600)) {
					gint64 hours = 0LL;
					gint64 _tmp67_;
					const gchar* _tmp68_;
					gint64 _tmp69_;
					gint64 _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
					_tmp67_ = seconds;
					hours = _tmp67_ / 3600;
					_tmp68_ = info;
					_tmp69_ = hours;
					_tmp70_ = hours;
					_tmp71_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until empty", "%lld hours until empty", (gulong) _tmp69_), _tmp70_);
					_tmp72_ = _tmp71_;
					_tmp73_ = g_strconcat (_tmp68_, _tmp72_, NULL);
					_g_free0 (info);
					info = _tmp73_;
					_g_free0 (_tmp72_);
				} else {
					gint64 _tmp74_;
					_tmp74_ = seconds;
					if (_tmp74_ >= ((gint64) 60)) {
						gint64 minutes = 0LL;
						gint64 _tmp75_;
						const gchar* _tmp76_;
						gint64 _tmp77_;
						gint64 _tmp78_;
						gchar* _tmp79_;
						gchar* _tmp80_;
						gchar* _tmp81_;
						_tmp75_ = seconds;
						minutes = _tmp75_ / 60;
						_tmp76_ = info;
						_tmp77_ = minutes;
						_tmp78_ = minutes;
						_tmp79_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until empty", "%lld minutes until empty", (gulong) _tmp77_), _tmp78_);
						_tmp80_ = _tmp79_;
						_tmp81_ = g_strconcat (_tmp76_, _tmp80_, NULL);
						_g_free0 (info);
						info = _tmp81_;
						_g_free0 (_tmp80_);
					} else {
						const gchar* _tmp82_;
						gint64 _tmp83_;
						gint64 _tmp84_;
						gchar* _tmp85_;
						gchar* _tmp86_;
						gchar* _tmp87_;
						_tmp82_ = info;
						_tmp83_ = seconds;
						_tmp84_ = seconds;
						_tmp85_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until empty", "%lld seconds until empty", (gulong) _tmp83_), _tmp84_);
						_tmp86_ = _tmp85_;
						_tmp87_ = g_strconcat (_tmp82_, _tmp86_, NULL);
						_g_free0 (info);
						info = _tmp87_;
						_g_free0 (_tmp86_);
					}
				}
			}
		}
	}
	result = info;
	return result;
}


void
power_utils_translations (void)
{
	ngettext ("%lld day until full", "%lld days until full", (gulong) 0);
	ngettext ("%lld hour until full", "%lld hours until full", (gulong) 0);
	ngettext ("%lld minute until full", "%lld minutes until full", (gulong) 0);
	ngettext ("%lld second until full", "%lld seconds until full", (gulong) 0);
	ngettext ("%lld day until empty", "%lld days until empty", (gulong) 0);
	ngettext ("%lld hour until empty", "%lld hours until empty", (gulong) 0);
	ngettext ("%lld minute until empty", "%lld minutes until empty", (gulong) 0);
	ngettext ("%lld second until empty", "%lld seconds until empty", (gulong) 0);
}



