/* DeviceList.c generated by valac 0.40.7, the Vala compiler
 * generated from DeviceList.vala, do not modify */

/*
 * Copyright (c) 2011-2016 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define POWER_WIDGETS_TYPE_DEVICE_LIST (power_widgets_device_list_get_type ())
#define POWER_WIDGETS_DEVICE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_WIDGETS_TYPE_DEVICE_LIST, PowerWidgetsDeviceList))
#define POWER_WIDGETS_DEVICE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_WIDGETS_TYPE_DEVICE_LIST, PowerWidgetsDeviceListClass))
#define POWER_WIDGETS_IS_DEVICE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_WIDGETS_TYPE_DEVICE_LIST))
#define POWER_WIDGETS_IS_DEVICE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_WIDGETS_TYPE_DEVICE_LIST))
#define POWER_WIDGETS_DEVICE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_WIDGETS_TYPE_DEVICE_LIST, PowerWidgetsDeviceListClass))

typedef struct _PowerWidgetsDeviceList PowerWidgetsDeviceList;
typedef struct _PowerWidgetsDeviceListClass PowerWidgetsDeviceListClass;
typedef struct _PowerWidgetsDeviceListPrivate PowerWidgetsDeviceListPrivate;
enum  {
	POWER_WIDGETS_DEVICE_LIST_0_PROPERTY,
	POWER_WIDGETS_DEVICE_LIST_NUM_PROPERTIES
};
static GParamSpec* power_widgets_device_list_properties[POWER_WIDGETS_DEVICE_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define POWER_SERVICES_TYPE_DEVICE (power_services_device_get_type ())
#define POWER_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice))
#define POWER_SERVICES_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))
#define POWER_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))

typedef struct _PowerServicesDevice PowerServicesDevice;
typedef struct _PowerServicesDeviceClass PowerServicesDeviceClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;

#define POWER_SERVICES_TYPE_DEVICE_MANAGER (power_services_device_manager_get_type ())
#define POWER_SERVICES_DEVICE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManager))
#define POWER_SERVICES_DEVICE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManagerClass))
#define POWER_SERVICES_IS_DEVICE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE_MANAGER))
#define POWER_SERVICES_IS_DEVICE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE_MANAGER))
#define POWER_SERVICES_DEVICE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManagerClass))

typedef struct _PowerServicesDeviceManager PowerServicesDeviceManager;
typedef struct _PowerServicesDeviceManagerClass PowerServicesDeviceManagerClass;

struct _PowerWidgetsDeviceList {
	GtkBox parent_instance;
	PowerWidgetsDeviceListPrivate * priv;
	GeeHashMap* entries;
};

struct _PowerWidgetsDeviceListClass {
	GtkBoxClass parent_class;
};

struct _Block3Data {
	int _ref_count_;
	PowerWidgetsDeviceList* self;
	GtkImage* device_image;
	GtkImage* battery_image;
	GtkLabel* title_label;
	GtkLabel* info_label;
	PowerServicesDevice* battery;
};


static gpointer power_widgets_device_list_parent_class = NULL;

GType power_widgets_device_list_get_type (void) G_GNUC_CONST;
PowerWidgetsDeviceList* power_widgets_device_list_new (void);
PowerWidgetsDeviceList* power_widgets_device_list_construct (GType object_type);
GType power_services_device_get_type (void) G_GNUC_CONST;
static void power_widgets_device_list_update_icons (PowerWidgetsDeviceList* self,
                                             PowerServicesDevice* battery,
                                             GtkImage* device_image,
                                             GtkImage* battery_image);
gboolean power_utils_type_has_device_icon (guint32 device_type);
guint32 power_services_device_get_device_type (PowerServicesDevice* self);
gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device);
gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery);
static void power_widgets_device_list_add_battery (PowerWidgetsDeviceList* self,
                                            const gchar* device_path,
                                            PowerServicesDevice* battery);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery);
#define DEVICE_TYPE_BATTERY ((guint32) 2)
static void __lambda5_ (Block3Data* _data3_);
static void ___lambda5__power_services_device_properties_updated (PowerServicesDevice* _sender,
                                                           gpointer self);
static void power_widgets_device_list_remove_battery (PowerWidgetsDeviceList* self,
                                               const gchar* device_path);
static GObject * power_widgets_device_list_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
GType power_services_device_manager_get_type (void) G_GNUC_CONST;
PowerServicesDeviceManager* power_services_device_manager_get_default (void);
static void _power_widgets_device_list_add_battery_power_services_device_manager_battery_registered (PowerServicesDeviceManager* _sender,
                                                                                              const gchar* device_path,
                                                                                              PowerServicesDevice* battery,
                                                                                              gpointer self);
static void _power_widgets_device_list_remove_battery_power_services_device_manager_battery_deregistered (PowerServicesDeviceManager* _sender,
                                                                                                   const gchar* device_path,
                                                                                                   gpointer self);
void power_services_device_manager_read_devices (PowerServicesDeviceManager* self);
static void power_widgets_device_list_finalize (GObject * obj);


PowerWidgetsDeviceList*
power_widgets_device_list_construct (GType object_type)
{
	PowerWidgetsDeviceList * self = NULL;
	self = (PowerWidgetsDeviceList*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
	return self;
}


PowerWidgetsDeviceList*
power_widgets_device_list_new (void)
{
	return power_widgets_device_list_construct (POWER_WIDGETS_TYPE_DEVICE_LIST);
}


static void
power_widgets_device_list_update_icons (PowerWidgetsDeviceList* self,
                                        PowerServicesDevice* battery,
                                        GtkImage* device_image,
                                        GtkImage* battery_image)
{
	guint32 _tmp0_;
	guint32 _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (battery != NULL);
	g_return_if_fail (device_image != NULL);
	g_return_if_fail (battery_image != NULL);
	_tmp0_ = power_services_device_get_device_type (battery);
	_tmp1_ = _tmp0_;
	if (power_utils_type_has_device_icon (_tmp1_)) {
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp2_ = power_utils_get_icon_name_for_device (battery);
		_tmp3_ = _tmp2_;
		gtk_image_set_from_icon_name (device_image, _tmp3_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
		_g_free0 (_tmp3_);
		_tmp4_ = power_utils_get_icon_name_for_battery (battery);
		_tmp5_ = _tmp4_;
		gtk_image_set_from_icon_name (battery_image, _tmp5_, (GtkIconSize) GTK_ICON_SIZE_DND);
		_g_free0 (_tmp5_);
	} else {
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp6_ = power_utils_get_icon_name_for_battery (battery);
		_tmp7_ = _tmp6_;
		gtk_image_set_from_icon_name (device_image, _tmp7_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
		_g_free0 (_tmp7_);
		gtk_image_clear (battery_image);
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		PowerWidgetsDeviceList* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->info_label);
		_g_object_unref0 (_data3_->title_label);
		_g_object_unref0 (_data3_->battery_image);
		_g_object_unref0 (_data3_->device_image);
		_g_object_unref0 (_data3_->battery);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static void
__lambda5_ (Block3Data* _data3_)
{
	PowerWidgetsDeviceList* self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	self = _data3_->self;
	_tmp0_ = _data3_->device_image;
	_tmp1_ = _data3_->battery_image;
	power_widgets_device_list_update_icons (self, _data3_->battery, _tmp0_, _tmp1_);
	_tmp2_ = _data3_->title_label;
	_tmp3_ = power_utils_get_title_for_battery (_data3_->battery);
	_tmp4_ = _tmp3_;
	gtk_label_set_markup (_tmp2_, _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = _data3_->info_label;
	_tmp6_ = power_utils_get_info_for_battery (_data3_->battery);
	_tmp7_ = _tmp6_;
	gtk_label_set_label (_tmp5_, _tmp7_);
	_g_free0 (_tmp7_);
}


static void
___lambda5__power_services_device_properties_updated (PowerServicesDevice* _sender,
                                                      gpointer self)
{
	__lambda5_ (self);
}


static void
power_widgets_device_list_add_battery (PowerWidgetsDeviceList* self,
                                       const gchar* device_path,
                                       PowerServicesDevice* battery)
{
	Block3Data* _data3_;
	PowerServicesDevice* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp8_;
	GtkOverlay* _tmp9_;
	GtkImage* _tmp10_;
	GtkOverlay* _tmp11_;
	GtkImage* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp28_;
	GtkGrid* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkOverlay* _tmp34_;
	GtkGrid* _tmp35_;
	GtkLabel* _tmp36_;
	GtkGrid* _tmp37_;
	GtkLabel* _tmp38_;
	GeeHashMap* _tmp39_;
	GtkGrid* _tmp40_;
	guint32 _tmp41_;
	guint32 _tmp42_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device_path != NULL);
	g_return_if_fail (battery != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (battery);
	_g_object_unref0 (_data3_->battery);
	_data3_->battery = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp1_);
	_data3_->device_image = _tmp1_;
	_tmp2_ = _data3_->device_image;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 3);
	_tmp3_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp3_);
	_data3_->battery_image = _tmp3_;
	_tmp4_ = _data3_->battery_image;
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_END);
	_tmp5_ = _data3_->battery_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
	_tmp6_ = _data3_->device_image;
	_tmp7_ = _data3_->battery_image;
	power_widgets_device_list_update_icons (self, _data3_->battery, _tmp6_, _tmp7_);
	_tmp8_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp8_);
	overlay = _tmp8_;
	_tmp9_ = overlay;
	_tmp10_ = _data3_->device_image;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = overlay;
	_tmp12_ = _data3_->battery_image;
	gtk_overlay_add_overlay (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = power_utils_get_title_for_battery (_data3_->battery);
	_tmp14_ = _tmp13_;
	_tmp15_ = (GtkLabel*) gtk_label_new (_tmp14_);
	g_object_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	_g_free0 (_tmp14_);
	_data3_->title_label = _tmp16_;
	_tmp17_ = _data3_->title_label;
	gtk_label_set_use_markup (_tmp17_, TRUE);
	_tmp18_ = _data3_->title_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
	_tmp19_ = _data3_->title_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_END);
	_tmp20_ = _data3_->title_label;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp20_, 6);
	_tmp21_ = power_utils_get_info_for_battery (_data3_->battery);
	_tmp22_ = _tmp21_;
	_tmp23_ = (GtkLabel*) gtk_label_new (_tmp22_);
	g_object_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	_g_free0 (_tmp22_);
	_data3_->info_label = _tmp24_;
	_tmp25_ = _data3_->info_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_START);
	_tmp26_ = _data3_->info_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp26_, GTK_ALIGN_START);
	_tmp27_ = _data3_->info_label;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp27_, 6);
	_tmp28_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp28_);
	grid = _tmp28_;
	_tmp29_ = grid;
	gtk_grid_set_column_spacing (_tmp29_, 3);
	_tmp30_ = grid;
	g_object_set ((GtkWidget*) _tmp30_, "margin", 6, NULL);
	_tmp31_ = grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp31_, 3);
	_tmp32_ = grid;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp32_, 3);
	_tmp33_ = grid;
	_tmp34_ = overlay;
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 0, 0, 1, 2);
	_tmp35_ = grid;
	_tmp36_ = _data3_->title_label;
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 1, 0, 1, 1);
	_tmp37_ = grid;
	_tmp38_ = _data3_->info_label;
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 1, 1, 1, 1);
	_tmp39_ = self->entries;
	_tmp40_ = grid;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, device_path, _tmp40_);
	_tmp41_ = power_services_device_get_device_type (_data3_->battery);
	_tmp42_ = _tmp41_;
	if (_tmp42_ == DEVICE_TYPE_BATTERY) {
		GtkGrid* _tmp43_;
		_tmp43_ = grid;
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp43_, TRUE, TRUE, (guint) 0);
	} else {
		GtkGrid* _tmp44_;
		_tmp44_ = grid;
		gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) _tmp44_, TRUE, TRUE, (guint) 0);
	}
	g_signal_connect_data (_data3_->battery, "properties-updated", (GCallback) ___lambda5__power_services_device_properties_updated, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (grid);
	_g_object_unref0 (overlay);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


static void
power_widgets_device_list_remove_battery (PowerWidgetsDeviceList* self,
                                          const gchar* device_path)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	GtkGrid* _tmp3_;
	GeeHashMap* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device_path != NULL);
	_tmp0_ = self->entries;
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, device_path)) {
		return;
	}
	_tmp1_ = self->entries;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, device_path);
	_tmp3_ = (GtkGrid*) _tmp2_;
	gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->entries;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, device_path, NULL);
}


static void
_power_widgets_device_list_add_battery_power_services_device_manager_battery_registered (PowerServicesDeviceManager* _sender,
                                                                                         const gchar* device_path,
                                                                                         PowerServicesDevice* battery,
                                                                                         gpointer self)
{
	power_widgets_device_list_add_battery ((PowerWidgetsDeviceList*) self, device_path, battery);
}


static void
_power_widgets_device_list_remove_battery_power_services_device_manager_battery_deregistered (PowerServicesDeviceManager* _sender,
                                                                                              const gchar* device_path,
                                                                                              gpointer self)
{
	power_widgets_device_list_remove_battery ((PowerWidgetsDeviceList*) self, device_path);
}


static GObject *
power_widgets_device_list_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerWidgetsDeviceList * self;
	GeeHashMap* _tmp0_;
	PowerServicesDeviceManager* dm = NULL;
	PowerServicesDeviceManager* _tmp1_;
	PowerServicesDeviceManager* _tmp2_;
	PowerServicesDeviceManager* _tmp3_;
	PowerServicesDeviceManager* _tmp4_;
	PowerServicesDeviceManager* _tmp5_;
	parent_class = G_OBJECT_CLASS (power_widgets_device_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_WIDGETS_TYPE_DEVICE_LIST, PowerWidgetsDeviceList);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_grid_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->entries);
	self->entries = _tmp0_;
	_tmp1_ = power_services_device_manager_get_default ();
	_tmp2_ = _g_object_ref0 (_tmp1_);
	dm = _tmp2_;
	_tmp3_ = dm;
	g_signal_connect_object (_tmp3_, "battery-registered", (GCallback) _power_widgets_device_list_add_battery_power_services_device_manager_battery_registered, self, 0);
	_tmp4_ = dm;
	g_signal_connect_object (_tmp4_, "battery-deregistered", (GCallback) _power_widgets_device_list_remove_battery_power_services_device_manager_battery_deregistered, self, 0);
	_tmp5_ = dm;
	power_services_device_manager_read_devices (_tmp5_);
	_g_object_unref0 (dm);
	return obj;
}


static void
power_widgets_device_list_class_init (PowerWidgetsDeviceListClass * klass)
{
	power_widgets_device_list_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = power_widgets_device_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = power_widgets_device_list_finalize;
}


static void
power_widgets_device_list_instance_init (PowerWidgetsDeviceList * self)
{
}


static void
power_widgets_device_list_finalize (GObject * obj)
{
	PowerWidgetsDeviceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_WIDGETS_TYPE_DEVICE_LIST, PowerWidgetsDeviceList);
	_g_object_unref0 (self->entries);
	G_OBJECT_CLASS (power_widgets_device_list_parent_class)->finalize (obj);
}


GType
power_widgets_device_list_get_type (void)
{
	static volatile gsize power_widgets_device_list_type_id__volatile = 0;
	if (g_once_init_enter (&power_widgets_device_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PowerWidgetsDeviceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_widgets_device_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerWidgetsDeviceList), 0, (GInstanceInitFunc) power_widgets_device_list_instance_init, NULL };
		GType power_widgets_device_list_type_id;
		power_widgets_device_list_type_id = g_type_register_static (gtk_box_get_type (), "PowerWidgetsDeviceList", &g_define_type_info, 0);
		g_once_init_leave (&power_widgets_device_list_type_id__volatile, power_widgets_device_list_type_id);
	}
	return power_widgets_device_list_type_id__volatile;
}



